package elec;

/**
 * Represents a switch with one input wire and two output terminals.
 * When the switch is UP, the input wire is connected to the UP output terminal.
 * When the switch is DOWN, the input wire is connected to the DOWN output terminal.
 */
public class BetterOne2TwoSwitch implements ITwoWaySwitch{
  
  // STUDENT TO ADD NESTED AND/OR INNER/ANONYMOUS CLASSES
  // TO IMPLEMENT STATE DESIGN PATTERN

  
  
  
  /**
   * The input wire to the switch
   */
  private IWire _inputWire;
  /**
   * The current state of the switch
   * STUDENT TO COMPLETE INITIALIZATION OF STATE
   */
  private AOne2TwoSwitchState state = null;
  
  /**
   * The constructor for the class
   * @param wire The input wire to the switch
   */
  public BetterOne2TwoSwitch(IWire wire) {
    _inputWire = wire;
  }
  
  /**
   * Set the switch to UP
   */
  public void setUp() {
    // STUDENT TO COMPLETE
        
    state = null;
  }
  
  /**
   * Set the switch to DOWN
   */
  public void setDown() {
    // STUDENT TO COMPLETE
    
    state = null;
  }
  
  /**
   * Factory method for a wire that returns 
   * the voltage on the UP Terminal
   * @return An IWire object
   */
  public IWire getVoltageUpWire() {
    // STUDENT TO COMPLETE
    
    return null;
  }
  
  /**
   * Factory method for a wire that returns 
   * the voltage on the DOWN Terminal
   * @return An IWire object
   */
  public IWire getVoltageDownWire() {
    // STUDENT TO COMPLETE
    
    return null;
  }
  
}




